net.sf.saxon.expr.sort

## Class CodepointCollatingComparer

- java.lang.Object
- - net.sf.saxon.expr.sort.CodepointCollatingComparer

- All Implemented Interfaces:
    Serializable, AtomicComparer

      public class CodepointCollatingComparer
      extends Object
      implements AtomicComparer

  An AtomicComparer used for comparing strings, untypedAtomic values, and URIs using the Unicode codepoint collation. A CodepointCollatingComparer is used when it is known in advance that both operands will be of these types, and when the collation is the unicode codepoint collation. This enables all conversions and promotions to be bypassed: the string values of both operands are simply extracted and passed to the collator for comparison.

  The difference between using this class and using the underlying CodepointCollator directly is that the compare() method in this class expects two instances of AtomicValue as its operands, whereas the underlying class expects two instances of java.lang.String. This class makes use of the extra information held in the wrapping StringValue object, specifically, the knowledge of whether the string contains surrogate pairs.

  Author:
    Michael H. Kay
  See Also:
    Serialized Form

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `compareAtomicValues(AtomicValue a, AtomicValue b)` Compare two AtomicValue objects according to the rules for their data type.
    `boolean` | `comparesEqual(AtomicValue a, AtomicValue b)` Compare two AtomicValue objects for equality.
    `StringCollator` | `getCollator()` Get the collation used by this AtomicComparer if any
    `ComparisonKey` | `getComparisonKey(AtomicValue a)` Get a comparison key for an object.
    `static CodepointCollatingComparer` | `getInstance()` Get the singular instance of this class
    `AtomicComparer` | `provideContext(XPathContext context)` Supply the dynamic context in case this is needed for the comparison

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### getInstance

          public static CodepointCollatingComparer getInstance()

      Get the singular instance of this class
      Returns:
        the singleton instance

    - #### getCollator

          public StringCollator getCollator()

      Description copied from interface: `AtomicComparer`
      Get the collation used by this AtomicComparer if any
      Specified by:
        `getCollator` in interface `AtomicComparer`
      Returns:
        the collation used for comparing strings, or null if not applicable

    - #### provideContext

          public AtomicComparer provideContext(XPathContext context)

      Supply the dynamic context in case this is needed for the comparison
      Specified by:
        `provideContext` in interface `AtomicComparer`
      Parameters:
        `context` - the dynamic evaluation context
      Returns:
        either the original AtomicComparer, or a new AtomicComparer in which the context is known. The original AtomicComparer is not modified

    - #### compareAtomicValues

          public int compareAtomicValues(AtomicValue a,
                                AtomicValue b)

      Compare two AtomicValue objects according to the rules for their data type. UntypedAtomic values are compared as if they were strings; if different semantics are wanted, the conversion must be done by the caller.
      Specified by:
        `compareAtomicValues` in interface `AtomicComparer`
      Parameters:
        `a` - the first object to be compared. This must be either be an instance of AtomicValue, or null to represent an empty sequence. Empty collates before non-empty.
        `b` - the second object to be compared. This must be either be an instance of AtomicValue, or null to represent an empty sequence.
      Returns:
        <0 if a0 if a>b
      Throws:
        `ClassCastException` - if the objects are not comparable

    - #### comparesEqual

          public boolean comparesEqual(AtomicValue a,
                              AtomicValue b)

      Compare two AtomicValue objects for equality. The values must be instances of xs:string or a type derived from xs:string. The method will also handle xs:untypedAtomic and xs:anyURI values.
      Specified by:
        `comparesEqual` in interface `AtomicComparer`
      Parameters:
        `a` - the first object to be compared.
        `b` - the second object to be compared.
      Returns:
        <0 if a0 if a>b
      Throws:
        `ClassCastException` - if either value is not xs:string or a subtype

    - #### getComparisonKey

          public ComparisonKey getComparisonKey(AtomicValue a)

      Get a comparison key for an object. This must satisfy the rule that if two objects are equal under the XPath eq operator, then their comparison keys are equal under the Java equals() function, and vice versa. There is no requirement that the comparison keys should reflect the ordering of the underlying objects.
      Specified by:
        `getComparisonKey` in interface `AtomicComparer`

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.